﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win.Misc;

namespace UltraSplitterWithScroll
{
   public partial class Form1 : Form
   {
      public Form1()
      {
         InitializeComponent();
      }


      public void AutoSizeParentPanel()
      {
          int currentHeight = ultraPanel1.ClientArea.Controls.Cast<Control>().Sum(p => p.Height);
          ultraPanel1.Height = (currentHeight >= this.Height) ? currentHeight : this.Height;
      }

      private void ultraSplitter1_SplitterDragging(object sender, Infragistics.Win.Misc.SplitterDraggingEventArgs e)
      {
          if (!((UltraExpandableGroupBox)e.TargetControl).Expanded) ((UltraExpandableGroupBox)e.TargetControl).Expanded = true;
          ultraPanel1.Height += e.NewTargetExtent;
      }

      private void ultraSplitter2_SplitterDragging(object sender, Infragistics.Win.Misc.SplitterDraggingEventArgs e)
      {
          if (!((UltraExpandableGroupBox)e.TargetControl).Expanded) ((UltraExpandableGroupBox)e.TargetControl).Expanded = true;
          ultraPanel1.Height += e.NewTargetExtent;
      }

      private void ultraSplitter1_SplitterDragCompleted(object sender, Infragistics.Win.Misc.SplitterDragCompletedEventArgs e)
      {
          AutoSizeParentPanel();
          this.ResumeLayout();
          ultraPanel1.EndUpdate();
      }

      private void ultraSplitter2_SplitterDragCompleted(object sender, Infragistics.Win.Misc.SplitterDragCompletedEventArgs e)
      {
          AutoSizeParentPanel();
          this.ResumeLayout();
          ultraPanel1.EndUpdate();
      }

      private void ultraExpandableGroupBox1_ExpandedStateChanged(object sender, EventArgs e)
      {
          AutoSizeParentPanel();
      }

      private void ultraExpandableGroupBox3_ExpandedStateChanged(object sender, EventArgs e)
      {
          AutoSizeParentPanel();
      }

      private void ultraExpandableGroupBox2_ExpandedStateChanged(object sender, EventArgs e)
      {
          AutoSizeParentPanel();
      }
   }
}
